Attribute VB_Name = "invrvnge"
Option Explicit

Dim EmuHandlers As type_EmuHandlers

Dim FrameSkip As Integer

Dim VirtualScreen(2, 248, 256) As Byte

Public Sub fn_PlayInvrvnge()
  '** Emulate the Space Invaders Part II hardware **
  Dim i As Integer, j As Integer
  Dim n As Long
  Dim x As Long
  Dim iNumHandlers As Integer
  Dim b_HiScore(1) As Byte

  ucIRQs = 0
  
  '** Tidy up by clearing all memory regions **
  fn_MemSet &H0, &H2FFFF, &H0
  '** Define Hardware, ROMs etc. **
  fn_DefineInvrvnge
  '** Setup Hardware **
  fn_InitInvrvnge
  '** Load the Invrvnge ROMs into Memory **
  If fn_LoadEmuRoms Then
    '** An Error has Occured **
    MsgBox "Error Loading Roms", vbCritical, "VBEmu Error"
  End If
  '** Setup the hardware emulation handlers addresses **
  '** These allow the DLL to call VB functions fn_read & fn_write **
  EmuHandlers.pfn_read = fn_GetFunctionPointer(AddressOf fn_Read)
  EmuHandlers.pfn_write = fn_GetFunctionPointer(AddressOf fn_Write)
'      }
'/* Mark this as ROM, not I/O since the IN/OUT handlers always call proc #2 */
'   memset(&mem_map[MEM_FLAGS], 1, 256);
  '** Reset the z80 processor to power-up state
  RESETZ80 RegsZ80
  '** Execute a few thousand instructions, usually for ROM/RAM checking **
  iClocks = 100000
  ucIRQs = 0
  EXECZ80 Mem_Map(0), RegsZ80, EmuHandlers, iClocks, ucIRQs, cIRQValue
  'fn_UpdateZ80Regs
  '** Load the hi-score table from the Registry **
  b_HiScore(0) = GetSetting("VBEmu", "HiScore", "0", 0)
  b_HiScore(1) = GetSetting("VBEmu", "HiScore", "1", 0)
  Mem_Map(MEM_RAM + &H20F4) = b_HiScore(0)
  Mem_Map(MEM_RAM + &H20F5) = b_HiScore(1)
  
  '** This is the main program loop    **
  '** Speed is a major concern here    **
  'We'll do things as fast as possible **
  Do While Not (KEY_ESC)
    For j = 0 To 1
      iClocks = 2000000 / 120
      If j And 1 Then
        ucIRQs = ucIRQs Or INT_IRQ
        cIRQValue = &HCF '; /* RST 08 = 8080's IRQ */
      Else
        RegsZ80.ucRegIFF1 = 1 '; /* Enable interrupts */
        ucIRQs = ucIRQs Or INT_IRQ
        cIRQValue = &HD7 '; /* RST 10 = 8080's NMI */
      End If
      'fn_UpdateZ80Regs
      EXECZ80 Mem_Map(0), RegsZ80, EmuHandlers, iClocks, ucIRQs, cIRQValue
      'fn_UpdateZ80Regs
    Next
  FrameSkip = FrameSkip + 1
  If FrameSkip > 4 Then
    fn_UpdateScreenInvrvnge
    FrameSkip = 0
  End If
'      iFrame++; /* Count the number of frames */
'/* Allow messages to flow while we waste time */
'      if (bThrottle)
'         EMUTimerDelay();
'//      EMUDoSound(TRUE); /* Second try after a little delay */
'      }
    DoEvents
  Loop
  '** Save the hi-score table to the Registry **
  b_HiScore(0) = Mem_Map(MEM_RAM + &H20F4)
  b_HiScore(1) = Mem_Map(MEM_RAM + &H20F5)
  SaveSetting "VBEmu", "HiScore", "0", b_HiScore(0)
  SaveSetting "VBEmu", "HiScore", "1", b_HiScore(1)
  VBEmu01.Screen.Cls
  fn_ClearScreenInvrvnge
  Debug.Print "Exited Emulation"
End Sub

Private Sub fn_InitInvrvnge()
  '** Set-up the flags area of memory to define the type **
  '** of hardware Memory i.e ROM, RAM, Video, I/O        **
  Dim n As Integer
  For n = 1 To UBound(MemInfo)
    fn_MemSet MEM_FLAGS + MemInfo(n).Start, MemInfo(1).Length, MemInfo(n).Type
  Next
  '** Resize the screen to suit game
  VBEmu01.Screen.Width = SCREEN_WIDTH
  VBEmu01.Screen.Height = SCREEN_HEIGHT
  'VBEmu01.Width = SCREEN_WIDTH * Screen.TwipsPerPixelX
  'VBEmu01.Height = SCREEN_HEIGHT * Screen.TwipsPerPixelY
'char keys[256];
  '** Clear out any pressed keys before beginning **
  KEY_ESC = False
'   GetAsyncKeyState(VK_ESCAPE); /* Important to clear this key */
'   memset(keys, 0, sizeof(keys));
'   SetKeyboardState(keys);
End Sub

Private Sub fn_Read()
'Public Function fn_Read(ByVal l_Addr As Long)
  Dim l_Byte As Long
  l_Byte = 0
  Debug.Print "Reading Invrvnge."
  'fn_Read = l_Byte
End Sub

Private Sub fn_Write()
'Public Sub fn_Write(ByVal l_Addr As Long, ByVal l_Byte As Long)
  Debug.Print "Writing Invrvnge."
End Sub

Private Function fn_GetFunctionPointer(l_FuncPtr As Long)
  fn_GetFunctionPointer = l_FuncPtr
End Function

Private Function fn_UpdateScreenInvrvnge()
  '** This is temporary due to the fact video read/write not available at present **
  Dim VideoRam As Long
  Dim ChosenBit As Integer
  Dim BitNum As Integer
  Dim Vx As Integer
  Dim Vy As Integer
  VideoRam = &H2400 + MEM_RAM
  BitNum = 0
  For Vx = 0 To 247
    For Vy = 255 To 0 Step -1
      ChosenBit = 2 ^ BitNum
        If Mem_Map(VideoRam) And ChosenBit Then
        VirtualScreen(0, Vx, Vy) = 1
      Else
        VirtualScreen(0, Vx, Vy) = 0
      End If
      BitNum = BitNum + 1
      If BitNum > 7 Then
        BitNum = 0
        VideoRam = VideoRam + 1
      End If
    Next
  Next
      
  For Vx = 0 To 247
    For Vy = 255 To 0 Step -1
      If VirtualScreen(0, Vx, Vy) <> VirtualScreen(1, Vx, Vy) Then
        VBEmu01.Screen.PSet (Vx, Vy), (VirtualScreen(0, Vx, Vy)) * &HFFFFFF
        VirtualScreen(1, Vx, Vy) = VirtualScreen(0, Vx, Vy)
      End If
    Next
  Next
  VBEmu01.Screen.Refresh
  VBEmu01.Screen.Visible = True
  'DoEvents
End Function

Private Sub fn_DefineInvrvnge()
  '** Define Rom Information **
  ReDim RomInfo(4)
  RomInfo(1).FileName = "invrvnge\invrvnge.h": RomInfo(1).Start = &H0: RomInfo(1).Length = &H800
  RomInfo(2).FileName = "invrvnge\invrvnge.g": RomInfo(2).Start = &H800: RomInfo(2).Length = &H800
  RomInfo(3).FileName = "invrvnge\invrvnge.f": RomInfo(3).Start = &H1000: RomInfo(3).Length = &H800
  RomInfo(4).FileName = "invrvnge\invrvnge.e": RomInfo(4).Start = &H1800: RomInfo(4).Length = &H800
  '** Define Memory Map Information
  ReDim MemInfo(3)
  MemInfo(1).Start = &H0: MemInfo(1).Length = &H2000: MemInfo(1).Type = FLAG_ROM
  MemInfo(2).Start = &H2000: MemInfo(2).Length = &H2000: MemInfo(2).Type = FLAG_RAM
  MemInfo(3).Start = &H2400: MemInfo(3).Length = &H1C00: MemInfo(3).Type = FLAG_RAM 'SPECIAL
  '** Define Screen Size **
  SCREEN_WIDTH = 247
  SCREEN_HEIGHT = 256
End Sub

Private Sub fn_ClearScreenInvrvnge()
  Dim Vx As Integer
  Dim Vy As Integer
  For Vx = 0 To 247
    For Vy = 255 To 0 Step -1
      VirtualScreen(0, Vx, Vy) = 0
      VirtualScreen(1, Vx, Vy) = 0
    Next
  Next

End Sub
